#include "SimStreamer.h"

uint8_t g_JPEG[300*1024] BSP_ALIGN_VARIABLE(8);

uint16_t SimStreamer::frames = 0;
SimStreamer::JPG_t * SimStreamer::JPG[256] = {NULL};

SimStreamer::SimStreamer(uint16_t w, uint16_t h) : CStreamer(w, h)
{
    idx = 0;

    APP_PRINT("Created streamer width=%d, height=%d\r\n", w, h);
}

SimStreamer::~SimStreamer()
{
    for(frames = 0; frames < (sizeof(JPG)/sizeof(JPG[0])); frames++)
        if(JPG[frames])
        {
            vPortFree((void *) JPG[frames]);
            JPG[frames] = NULL;
        }
    frames = 0;
}

uint16_t SimStreamer::loadJPEG(FF_FindData_t * jpeg)
{
    if(frames < (sizeof(JPG)/sizeof(JPG[0])))
    {
        if(JPG[frames] == NULL)
        {
            JPG[frames] = (JPG_t *) pvPortMalloc(sizeof(JPG_t));
            if(JPG[frames])
            {
                strcpy(JPG[frames]->FileName, jpeg->pcFileName);
                JPG[frames]->FileSize = jpeg->ulFileSize;
                frames++;
                return frames;
            }
            else
                return 0;
        }
        else
            return 0;
    }
    else
        return 0;
}

void SimStreamer::streamImage(uint32_t curMsec)
{
    if(frames)
    {
        if(JPG[idx]->FileSize < sizeof(g_JPEG) )
        {
            FF_FILE *file_pointer = ff_fopen(JPG[idx]->FileName, "r");

            if(file_pointer)
            {
                if(JPG[idx]->FileSize != ff_fread(g_JPEG, sizeof(g_JPEG[0]), JPG[idx]->FileSize, file_pointer))
                    APP_PRINT("ff_fread API failed [%d]\r\n", stdioGET_ERRNO());
                else
                    streamFrame(g_JPEG, JPG[idx]->FileSize, curMsec);

                if(FF_ERR_NONE != ff_fclose(file_pointer))
                    APP_PRINT("ff_fclose API failed [%d]\r\n", stdioGET_ERRNO());
            }
            else
                APP_PRINT("ff_fopen API failed [%d | %d (%s)]\r\n", stdioGET_ERRNO(), idx, JPG[idx]->FileName);
        }
        else
            APP_PRINT("Frame skipped! QSPI:/%s is too big, max frame size is %d\r\n", JPG[idx]->FileSize, sizeof(g_JPEG));

        if(++idx >= frames)
            idx = 0;
    }
    else
        APP_ERR_PRINT ("No Frames in QSPI drive!\r\n");
}
