/* -------------------------------------------------------------------------+
 |                             Vekatech Ltd.                                |
 + -------------------------------------------------------------------------*/

/* --------------------------- COPYRIGHT INFORMATION -----------------------+
 |                                                                          |
 |                                                                          |
 |                                                                          |
 |                                                                          |
 + -------------------------------------------------------------------------*/

/* -------------------------------------------------------------------------+
 | Module        : <mandatory>
 | File name     : <mandatory>
 | Description   : <mandatory>
 | Reference(s)  : <mandatory>
 + -------------------------------------------------------------------------*/



/* -------------------------------------------------------------------------+
 |   HEADER (INCLUDE) SECTION                                               |
 + -------------------------------------------------------------------------*/

#include "CRtspSession.h"
#include "SimStreamer.h"
#include "server.h"

/* -------------------------------------------------------------------------+
 |   EXTERNAL DATA (+ meaning)                                              |
 + -------------------------------------------------------------------------*/

/* none */

/* -------------------------------------------------------------------------+
 |   MACROS                                                                 |
 + -------------------------------------------------------------------------*/

#define ON      BSP_IO_LEVEL_HIGH
#define OFF     BSP_IO_LEVEL_LOW

#define SET(led, lvl)     R_IOPORT_PinWrite(&g_ioport_ctrl, led, lvl)

/* -------------------------------------------------------------------------+
 |   TYPE DEFINITIONS                                                       |
 + -------------------------------------------------------------------------*/

/* none */
 
/* -------------------------------------------------------------------------+
 |   GLOBAL CONSTANTS                                                       |
 + -------------------------------------------------------------------------*/

/* none */

/* -------------------------------------------------------------------------+
 |   GLOBAL VARIABLES                                                       |
 + -------------------------------------------------------------------------*/

/* none */

/* -------------------------------------------------------------------------+
 |   LOCAL FUNCTION PROTOTYPES                                              |
 + -------------------------------------------------------------------------*/

/* none */

/* -------------------------------------------------------------------------+
 |   LOCAL  VARIABLES                                                       |
 + -------------------------------------------------------------------------*/

TaskHandle_t xTaskServer = NULL;

/* -------------------------------------------------------------------------+
 |   LOCAL FUNCTIONS                                                        |                                         
 + -------------------------------------------------------------------------*/

/* none */

/* -------------------------------------------------------------------------+
 |   GLOBAL FUNCTIONS                                                       |
 + -------------------------------------------------------------------------*/

void HandleClients(void)
{
    TickType_t stamp = 0ul;
    SOCKET rtspServer = NULL, rtspClient = NULL;
    struct freertos_sockaddr xBindAddress = {sizeof(struct freertos_sockaddr), FREERTOS_AF_INET, FreeRTOS_htons(8554), 0};
    struct freertos_sockaddr xClient;

    SimStreamer stream(1280, 720);
    CRtspSession session(&stream);

    rtspServer = FreeRTOS_socket( FREERTOS_AF_INET, FREERTOS_SOCK_STREAM, FREERTOS_IPPROTO_TCP );

    if( rtspServer == FREERTOS_INVALID_SOCKET )
    {
        APP_ERR_PRINT("Socket Error : FreeRTOS_socket Failed");
        APP_ERR_TRAP(rtspServer);
    }

    FreeRTOS_bind(rtspServer, &xBindAddress, xBindAddress.sin_len);
    FreeRTOS_listen(rtspServer, 2);

    xTaskServer = xTaskGetCurrentTaskHandle();

    while(true)
    {
        if(session.isAlive())
        {
            session.handleRequests(0);

            if(ulTaskNotifyTake(pdTRUE, 0))
            {
                if (session.m_streaming && stream.hasFrame())
                {
                    session.broadcastCurrentFrame(stamp);
                    stamp+=50;
                }
            }

            // Handle disconnection from RTSP client
            if (session.m_stopped)
            {
                APP_PRINT("RTSP client closed connection\r\n");
                session.Destroy();
                stream.Close();
                SET(LED_R, OFF);
                R_GPT_Stop(&g_FPS_ctrl);
            }
        }
        else
        {
            socklen_t xSize = sizeof( xClient );

            rtspClient = FreeRTOS_accept( rtspServer, &xClient, &xSize );

            // Handle connection request from RTSP client
            if((rtspClient != NULL) && (rtspClient != FREERTOS_INVALID_SOCKET))
            {
                APP_PRINT("RTSP client started connection\r\n");

                stamp = 0;
                stream.Open(rtspClient);
                session.Create(rtspClient);

                SET(LED_R, ON);
                R_GPT_Start(&g_FPS_ctrl);
            }
        }
    }
}

void fps_ISR(timer_callback_args_t * p_args)
{
    BaseType_t xHigherPriorityTaskWoken = pdFALSE;

    if((NULL != p_args) && (xTaskServer != NULL))
    {
        if (TIMER_EVENT_CYCLE_END  == p_args->event)
        {
            vTaskNotifyGiveFromISR( xTaskServer, &xHigherPriorityTaskWoken);
            portYIELD_FROM_ISR( xHigherPriorityTaskWoken );
        }
    }
}

/* -------------------------------------------------------------------------+
 |   END                                                                    |
 + -------------------------------------------------------------------------*/
